.486
.model	flat, stdcall
option	casemap :none   ; case sensitive

include		base.inc

.code
start:
	invoke	GetModuleHandle, NULL
	mov	hInstance, eax
	invoke	DialogBoxParam, hInstance, 101, 0, ADDR DlgProc, 0
	invoke	ExitProcess, eax
; -----------------------------------------------------------------------
DlgProc	proc	uses edi hWnd :DWORD,uMsg :DWORD,wParam :DWORD,lParam :DWORD

	.if uMsg == WM_INITDIALOG
	push hWnd
	pop hDlg
	invoke GetDlgItem, hDlg, IDC_LISTVIEW
	mov hListview, eax
	call initlistview
	.elseif	uMsg == WM_COMMAND

	.elseif uMsg == WM_NOTIFY
		.if wParam == IDC_LISTVIEW
		mov edi,lParam
		assume edi:ptr NMHDR
			.if [edi].code == LVN_ITEMCHANGING
			
			.elseif [edi].code == NM_CLICK		;user left clicked
			call checkboxhittest
			.elseif [edi].code == NM_DBLCLK		;user double left clicked
			call checkboxhittest
			.endif
		assume edi:nothing
		.endif
	.elseif	uMsg == WM_CLOSE
	invoke ImageList_Destroy, hCheckboxImgList
	invoke	EndDialog,hWnd,0
	.endif

	xor	eax,eax
	ret
DlgProc	endp


initlistview proc
LOCAL lvc:LVCOLUMN
LOCAL hImage:HANDLE
LOCAL lvi:LVITEM

mov lvc.imask, LVCF_WIDTH
mov lvc.lx, 200 							;column width
invoke SendMessage, hListview, LVM_INSERTCOLUMN, 0, ADDR lvc
invoke ImageList_Create, 16d, 16d, ILC_COLOR24, 3, 0	;returns a handle to a HIMAGELIST
mov hCheckboxImgList, eax

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;                                    Load Checkbox Images
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;Load Unchecked box
invoke LoadBitmap, hInstance, ID_UNCHECKED
mov hImage, eax
invoke ImageList_Add, hCheckboxImgList, hImage, NULL	;returns index of the new image in the list
invoke DeleteObject, hImage
;Load Checked box
invoke LoadBitmap, hInstance, ID_CHECKED
mov hImage, eax
invoke ImageList_Add, hCheckboxImgList, hImage, NULL	;returns index of the new image in the list
invoke DeleteObject, hImage
;Load Indeterminate box
invoke LoadBitmap, hInstance, ID_INDETERMINATE
mov hImage, eax
invoke ImageList_Add, hCheckboxImgList, hImage, NULL	;returns index of the new image in the list
invoke DeleteObject, hImage
;Set the state imagelist for the listview
invoke SendMessage, hListview, LVM_SETIMAGELIST, LVSIL_STATE, hCheckboxImgList

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;                                         Insert Items
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
mov lvi.imask, LVIF_TEXT or LVIF_STATE				;adding text and state
mov lvi.iItem, 0									;row number
mov lvi.iSubItem, 0 								;column number
mov lvi.pszText, offset szItem1						;text to show
mov lvi.state, (1 SHL 12)							;item state
mov lvi.stateMask, LVIS_STATEIMAGEMASK
invoke SendMessage, hListview, LVM_INSERTITEM, 0, addr lvi

mov lvi.imask, LVIF_TEXT or LVIF_STATE				;adding text and state
mov lvi.iItem, 1									;row number
mov lvi.iSubItem, 0 								;column number
mov lvi.pszText, offset szItem2						;text to show
mov lvi.state, (2 SHL 12)							;item state
mov lvi.stateMask, LVIS_STATEIMAGEMASK
invoke SendMessage, hListview, LVM_INSERTITEM, 0, addr lvi

mov lvi.imask, LVIF_TEXT or LVIF_STATE				;adding text and state
mov lvi.iItem, 2									;row number
mov lvi.iSubItem, 0 								;column number
mov lvi.pszText, offset szItem3						;text to show
mov lvi.state, (3 SHL 12)							;item state
mov lvi.stateMask, LVIS_STATEIMAGEMASK
invoke SendMessage, hListview, LVM_INSERTITEM, 0, addr lvi

	ret
initlistview endp

checkboxhittest proc
LOCAL lvi:LVITEM
LOCAL lvh:LVHITTESTINFO

invoke GetMessagePos	;x is low order and y is high order
mov ecx, eax 
and eax, 0FFFFh 	;zero out the top of eax (x)
shr ecx, 16			;shift the top over (y)
mov [lvh.pt.x], eax
mov [lvh.pt.y], ecx
invoke ScreenToClient, hListview, addr lvh.pt
invoke SendMessage, hListview, LVM_HITTEST, NULL, addr lvh
	.if eax == -1
	ret
	.endif
mov eax, lvh.flags
	.if eax == LVHT_ONITEMSTATEICON		;user clicked on a checkbox
	mov eax, lvh.iItem
	mov lvi.iItem, eax
	mov lvi.iSubItem, 0					;column
	mov lvi.imask, LVIF_STATE 	
	mov lvi.stateMask, LVIS_STATEIMAGEMASK
	invoke SendMessage, hListview, LVM_GETITEM, 0, addr lvi ;get the state of the item
	mov eax, lvi.state
	shr eax, 12
		.if eax == 1
		mov lvi.state, (2 SHL 12)
		invoke SendMessage, hListview, LVM_SETITEM, NULL, addr lvi
		.elseif eax == 2
		mov lvi.state, (3 SHL 12)
		invoke SendMessage, hListview, LVM_SETITEM, NULL, addr lvi
		.elseif eax == 3
		mov lvi.state, (1 SHL 12)
		invoke SendMessage, hListview, LVM_SETITEM, NULL, addr lvi
		.endif
	.endif
	ret
checkboxhittest endp
end start
